/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-hydro-program-queue-1.0.7-0precise-20150328-1117/srv/CallProgram.srv
 *
 */


#ifndef PROGRAM_QUEUE_MESSAGE_CALLPROGRAMRESPONSE_H
#define PROGRAM_QUEUE_MESSAGE_CALLPROGRAMRESPONSE_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace program_queue
{
template <class ContainerAllocator>
struct CallProgramResponse_
{
  typedef CallProgramResponse_<ContainerAllocator> Type;

  CallProgramResponse_()
    : ret(0)
    , output()  {
    }
  CallProgramResponse_(const ContainerAllocator& _alloc)
    : ret(0)
    , output(_alloc)  {
    }



   typedef int8_t _ret_type;
  _ret_type ret;

   typedef std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  _output_type;
  _output_type output;




  typedef boost::shared_ptr< ::program_queue::CallProgramResponse_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::program_queue::CallProgramResponse_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct CallProgramResponse_

typedef ::program_queue::CallProgramResponse_<std::allocator<void> > CallProgramResponse;

typedef boost::shared_ptr< ::program_queue::CallProgramResponse > CallProgramResponsePtr;
typedef boost::shared_ptr< ::program_queue::CallProgramResponse const> CallProgramResponseConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::program_queue::CallProgramResponse_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::program_queue::CallProgramResponse_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace program_queue

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': False}
// {'std_msgs': ['/opt/ros/hydro/share/std_msgs/cmake/../msg'], 'program_queue': ['/tmp/buildd/ros-hydro-program-queue-1.0.7-0precise-20150328-1117/msg'], 'geometry_msgs': ['/opt/ros/hydro/share/geometry_msgs/cmake/../msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::program_queue::CallProgramResponse_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::program_queue::CallProgramResponse_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::program_queue::CallProgramResponse_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::program_queue::CallProgramResponse_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::program_queue::CallProgramResponse_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::program_queue::CallProgramResponse_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::program_queue::CallProgramResponse_<ContainerAllocator> >
{
  static const char* value()
  {
    return "2eff6845394abf92e7d666096639cded";
  }

  static const char* value(const ::program_queue::CallProgramResponse_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x2eff6845394abf92ULL;
  static const uint64_t static_value2 = 0xe7d666096639cdedULL;
};

template<class ContainerAllocator>
struct DataType< ::program_queue::CallProgramResponse_<ContainerAllocator> >
{
  static const char* value()
  {
    return "program_queue/CallProgramResponse";
  }

  static const char* value(const ::program_queue::CallProgramResponse_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::program_queue::CallProgramResponse_<ContainerAllocator> >
{
  static const char* value()
  {
    return "\n\
int8 ret\n\
\n\
string output\n\
\n\
";
  }

  static const char* value(const ::program_queue::CallProgramResponse_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::program_queue::CallProgramResponse_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.ret);
      stream.next(m.output);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct CallProgramResponse_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::program_queue::CallProgramResponse_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::program_queue::CallProgramResponse_<ContainerAllocator>& v)
  {
    s << indent << "ret: ";
    Printer<int8_t>::stream(s, indent + "  ", v.ret);
    s << indent << "output: ";
    Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.output);
  }
};

} // namespace message_operations
} // namespace ros

#endif // PROGRAM_QUEUE_MESSAGE_CALLPROGRAMRESPONSE_H
