/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-hydro-program-queue-1.0.7-0precise-20150328-1117/msg/ProgramInfo.msg
 *
 */


#ifndef PROGRAM_QUEUE_MESSAGE_PROGRAMINFO_H
#define PROGRAM_QUEUE_MESSAGE_PROGRAMINFO_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace program_queue
{
template <class ContainerAllocator>
struct ProgramInfo_
{
  typedef ProgramInfo_<ContainerAllocator> Type;

  ProgramInfo_()
    : id(0)
    , name()
    , type(0)
    , owner()  {
    }
  ProgramInfo_(const ContainerAllocator& _alloc)
    : id(0)
    , name(_alloc)
    , type(0)
    , owner(_alloc)  {
    }



   typedef uint64_t _id_type;
  _id_type id;

   typedef std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  _name_type;
  _name_type name;

   typedef int8_t _type_type;
  _type_type type;

   typedef std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  _owner_type;
  _owner_type owner;


    enum { PYTHON = 1 };
     enum { PUPPET = 2 };
     enum { SLIDER = 3 };
 

  typedef boost::shared_ptr< ::program_queue::ProgramInfo_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::program_queue::ProgramInfo_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct ProgramInfo_

typedef ::program_queue::ProgramInfo_<std::allocator<void> > ProgramInfo;

typedef boost::shared_ptr< ::program_queue::ProgramInfo > ProgramInfoPtr;
typedef boost::shared_ptr< ::program_queue::ProgramInfo const> ProgramInfoConstPtr;

// constants requiring out of line definition

   

   

   



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::program_queue::ProgramInfo_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::program_queue::ProgramInfo_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace program_queue

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': False}
// {'std_msgs': ['/opt/ros/hydro/share/std_msgs/cmake/../msg'], 'program_queue': ['/tmp/buildd/ros-hydro-program-queue-1.0.7-0precise-20150328-1117/msg'], 'geometry_msgs': ['/opt/ros/hydro/share/geometry_msgs/cmake/../msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::program_queue::ProgramInfo_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::program_queue::ProgramInfo_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::program_queue::ProgramInfo_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::program_queue::ProgramInfo_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::program_queue::ProgramInfo_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::program_queue::ProgramInfo_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::program_queue::ProgramInfo_<ContainerAllocator> >
{
  static const char* value()
  {
    return "f9bcf51e255d86f0fc5da73cdc9def70";
  }

  static const char* value(const ::program_queue::ProgramInfo_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0xf9bcf51e255d86f0ULL;
  static const uint64_t static_value2 = 0xfc5da73cdc9def70ULL;
};

template<class ContainerAllocator>
struct DataType< ::program_queue::ProgramInfo_<ContainerAllocator> >
{
  static const char* value()
  {
    return "program_queue/ProgramInfo";
  }

  static const char* value(const ::program_queue::ProgramInfo_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::program_queue::ProgramInfo_<ContainerAllocator> >
{
  static const char* value()
  {
    return "uint64 id\n\
string name\n\
int8 type\n\
int8 PYTHON=1\n\
int8 PUPPET=2\n\
int8 SLIDER=3\n\
string owner\n\
";
  }

  static const char* value(const ::program_queue::ProgramInfo_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::program_queue::ProgramInfo_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.id);
      stream.next(m.name);
      stream.next(m.type);
      stream.next(m.owner);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct ProgramInfo_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::program_queue::ProgramInfo_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::program_queue::ProgramInfo_<ContainerAllocator>& v)
  {
    s << indent << "id: ";
    Printer<uint64_t>::stream(s, indent + "  ", v.id);
    s << indent << "name: ";
    Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.name);
    s << indent << "type: ";
    Printer<int8_t>::stream(s, indent + "  ", v.type);
    s << indent << "owner: ";
    Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.owner);
  }
};

} // namespace message_operations
} // namespace ros

#endif // PROGRAM_QUEUE_MESSAGE_PROGRAMINFO_H
